<template>
  <fieldset>
    <CheckboxBorderedLabel for="customInput" :text="t('customInput_label')">
      <input
        type="checkbox"
        id="customInput"
        name="customInput"
        :checked="currentSettings.customInput"
      />
    </CheckboxBorderedLabel>

    <div v-show="currentSettings.customInput" class="inline">
      <select name="inputType" id="inputType">
        <option
          v-for="(val, key) in $options.inputTypes"
          :value="val.type"
          :key="key"
          :selected="val.type === currentSettings.inputType"
          >{{ t(val.text) }}</option
        >
      </select>
      <TextInputFloatingLabel for="content" :text="t('content_label')">
        <input
          :type="currentSettings.inputType"
          name="content"
          id="content"
          :value="currentSettings.content"
          :placeholder="placeholderForInputType()"
          maxlength="500"
        />
      </TextInputFloatingLabel>
    </div>
    <p v-if="!currentSettings.customInput">
      {{ t("default_description") }}
    </p>
  </fieldset>
</template>

<script>
module.exports = {
  name: "qrcode",
  props: {
    currentSettings: {
      type: Object,
      required: true,
    },
    locale: {
      type: String,
      required: true
    }
  },
  inputTypes: [
    { type: "url", text: "url_label" },
    { type: "text", text: "text_label" },
    { type: "tel", text: "tel_label" }
    // TODO: WiFi access and contact card, possibly event and geolocation
  ],
  methods: {
    placeholderForInputType: function() {
      switch (this.currentSettings.inputType) {
        case "tel":
          return "+49123456789";
        case "url":
          return "https://glancr.de";
        case "text":
          return this.$translate.text("text_placeholder");
        default:
          return this.$translate.text("text_placeholder");
      }
    },
  },
  locales: {
    enGb: {
      customInput_label: "use custom content instead",
      default_description:
        "QR code contains a link to the current IP address of your glancr for easy configuration access.",
      content_label: "content of the QR code",
      url_label: "URL",
      text_label: "free-form text",
      tel_label: "phone number",
      text_placeholder: "any text (max. 500 characters)"
    },
    deDe: {
      customInput_label: "Eigenen Inhalt verwenden",
      default_description:
        "Der QR-Code enthält einen Link zur aktuellen IP-Adresse deines glancr, um einfach auf die Konfiguration zu gelangen.",
      content_label: "Inhalt des QR-Codes",
      url_label: "URL",
      text_label: "Freitext",
      tel_label: "Telefonnummer",
      text_placeholder: "beliebiger Text (max. 500 Zeichen)"
    },
    frFr: {
      customInput_label: "utiliser du contenu personnalisé à la place",
      default_description:
        "QR code contient un lien vers l'adresse IP actuelle de votre glancr pour faciliter l'accès à la configuration.",
      content_label: "contenu du code QR",
      url_label: "URL",
      text_label: "texte libre",
      tel_label: "numéro de téléphone",
      text_placeholder: "n'importe quel texte (max. 500 caractères)"
    },
    esEs: {
      customInput_label: "usar contenido personalizado en su lugar",
      default_description:
        "El código QR contiene un enlace a la dirección IP actual de su navegador para facilitar el acceso a la configuración.",
      content_label: "contenido del código QR",
      url_label: "URL",
      text_label: "texto libre",
      tel_label: "número de teléfono",
      text_placeholder: "cualquier texto (máx. 500 caracteres)"
    },
    plPl: {
      customInput_label:
        "wykorzystanie zawartości niestandardowej zamiast tego",
      default_description:
        "Kod QR zawiera link do aktualnego adresu IP glancr w celu łatwej konfiguracji.",
      content_label: "treść kodu QR",
      url_label: "URL",
      text_label: "tekst w formie swobodnej",
      tel_label: "numer telefonu",
      text_placeholder: "dowolny tekst (maks. 500 znaków)"
    },
    koKr: {
      customInput_label: "대신 맞춤 콘텐츠를 사용하십시오.",
      default_description:
        "QR 코드에는 쉬운 구성 액세스를 위해 glancr의 현재 IP 주소에 대한 링크가 포함되어 있습니다.",
      content_label: "QR 코드의 내용",
      url_label: "URL",
      text_label: "자유형 텍스트",
      tel_label: "전화 번호",
      text_placeholder: "모든 텍스트 (최대 500 자)"
    }
  }
};
</script>
<style scoped>
.inline {
  display: flex;
  justify-content: space-between;
}
.inline select {
  width: 25%;
  text-align: center;
}
.inline .floating-label {
  width: 72.5%;
}
</style>
